﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using System.Text.RegularExpressions;

namespace Xenon.TesterRegexp
{
    public partial class Uc_Main : UserControl
    {
        public Uc_Main()
        {
            InitializeComponent();
        }

        /// <summary>
        /// [１つ検索]
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnMatch_Click(object sender, EventArgs e)
        {
            if (this.rdiFind.Checked)
            {
                // 検索
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                this.txtResult.Text = "";

                Regex regex = new Regex(this.txtPattern.Text);

                Match m = regex.Match(this.txtInput.Text);

                if (!m.Success)
                {
                    this.txtResult.Text = "一致する箇所はありませんでした。";
                    goto gt_EndMethod;
                }

                this.txtResult.Text = m.Value;
            }
            else if (this.rdiReplace.Checked)
            {
                // 置換
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                this.txtResult.Text = "";

                Regex regex = new Regex(this.txtPattern.Text);

                this.txtResult.Text = regex.Replace(this.txtInput.Text, this.txtReplace.Text, 1);
            }

        gt_EndMethod:
            ;
        }

        /// <summary>
        /// [全て検索]
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnMatches_Click(object sender, EventArgs e)
        {
            if (this.rdiFind.Checked)
            {
                // 検索
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                this.txtResult.Text = "";

                Regex regex = new Regex(this.txtPattern.Text);

                MatchCollection mc = regex.Matches(this.txtInput.Text);

                StringBuilder sb = new StringBuilder();

                foreach (Match m in mc)
                {
                    sb.AppendLine(m.Value);
                }

                this.txtResult.Text = sb.ToString();
            }
            else if (this.rdiReplace.Checked)
            {
                // 置換
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                this.txtResult.Text = "";

                Regex regex = new Regex(this.txtPattern.Text);

                this.txtResult.Text = regex.Replace(this.txtInput.Text, this.txtReplace.Text);
            }
        }

        private void Uc_Main_Load(object sender, EventArgs e)
        {
            this.lstPractice.Items.Add("数字にヒット");
            this.lstPractice.Items.Add("携帯電話番号");
            this.lstPractice.Items.Add("目隠し将棋");
            this.lstPractice.Items.Add("SQLを引っぺがす");

            this.lstPractice.SetSelected(0,true);
        }

        /// <summary>
        /// [練習サンプルをセット]
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnPractice_Click(object sender, EventArgs e)
        {
            string title = (string)this.lstPractice.SelectedItem;

            switch(title)
            {
                case "数字にヒット":
                    {
                        this.txtPattern.Text = @"\d+";

                        StringBuilder sb = new StringBuilder();
                        sb.AppendLine("「数字を読み上げていきますので、");
                        sb.AppendLine("　縦、横、斜めのどこでも１列揃った方は");
                        sb.AppendLine("　大声でビンゴと言ってください。");
                        sb.AppendLine("　35、89、25」");
                        sb.AppendLine("「ビンゴ！」");
                        sb.AppendLine("「まだ説明中です」");
                        sb.AppendLine("「え～！！」");
                        this.txtInput.Text = sb.ToString();

                        this.rdiFind.Checked = true;
                    }
                    break;

                case "携帯電話番号":
                    {
                        this.txtPattern.Text = @"\d+-\d+-\d+";

                        StringBuilder sb = new StringBuilder();
                        sb.AppendLine("「太子様のお耳は、同時に１０人の声を聞き分けることができる。");
                        sb.AppendLine("　相談のある者は　返事をするので　携帯電話番号を言うがよい」");
                        sb.AppendLine("");
                        sb.AppendLine("１「電話番号は 012-3456-7890 だ！」");
                        sb.AppendLine("２「私の電話番号は 246-8024-6810 です～」");
                        sb.AppendLine("３「わしの電話番号は 135-7913-5791 じゃよ」");
                        sb.AppendLine("４「112-233-4455 です」");
                        sb.AppendLine("５「987-6543-2101 ！」");
                        sb.AppendLine("６「電話番号は、333-4444-5555 です」");
                        sb.AppendLine("７「6666-77-8888 なのです」");
                        sb.AppendLine("８「電話番号は 121-2121-2121 です」");
                        sb.AppendLine("９「0123-0123-0123 だよ」");
                        sb.AppendLine("１０「9876-5432-1098 だ」");
                        this.txtInput.Text = sb.ToString();

                        this.rdiFind.Checked = true;
                    }
                    break;

                case "目隠し将棋":
                    {
                        this.txtPattern.Text = @"[▲△](?:同|[１２３４５６７８９][一二三四五六七八九])(歩|香|桂|銀|金|飛|角|王|玉|と|成香|成桂|成銀|竜|馬)(右|左|直|打)?";

                        StringBuilder sb = new StringBuilder();
                        sb.AppendLine("「▲５八歩！」");
                        sb.AppendLine("「△３四歩」");
                        sb.AppendLine("「▲５八飛　中飛車！」");
                        sb.AppendLine("「△５四歩！」");
                        sb.AppendLine("「▲５五歩！」");
                        sb.AppendLine("「△同歩！」");
                        sb.AppendLine("「▲同飛！」");
                        sb.AppendLine("「△同飛！」");
                        sb.AppendLine("「いや、飛車が斜めに飛んできたんだが」");
                        this.txtInput.Text = sb.ToString();

                        this.rdiFind.Checked = true;
                    }
                    break;

                case "SQLを引っぺがす":
                    {
                        this.txtPattern.Text = @"\s*[+]?\s*""([^""]*)\\n""\s*";
                        this.txtReplace.Text = @"$1";

                        StringBuilder sb = new StringBuilder();
                        sb.AppendLine(@" sql = "" SELECT\n""");
                        sb.AppendLine(@"     + ""     *\n""");
                        sb.AppendLine(@"     + "" FROM\n""");
                        sb.AppendLine(@"     + ""     URIAGE\n""");
                        this.txtInput.Text = sb.ToString();

                        this.rdiReplace.Checked = true;
                    }
                    break;

                default:
                    this.txtPattern.Text = "";
                    this.txtInput.Text = "";
                    break;
            }

            this.txtResult.Text = "";
        }

        /// <summary>
        /// [検索]ラジオボタン
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rdiFind_CheckedChanged(object sender, EventArgs e)
        {
            //------------------------------------------------------------
            // 非表示：     置換コントロール
            //------------------------------------------------------------
            this.lblReplace.Visible = false;
            this.txtReplace.Visible = false;
            this.btnMatch.Text = "１つ検索";
            this.btnMatches.Text = "全て検索";
        }

        /// <summary>
        /// [置換]ラジオボタン
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rdiReplace_CheckedChanged(object sender, EventArgs e)
        {
            //------------------------------------------------------------
            // 表示：     置換コントロール
            //------------------------------------------------------------
            this.lblReplace.Visible = true;
            this.txtReplace.Visible = true;
            this.btnMatch.Text = "１つ置換";
            this.btnMatches.Text = "全て置換";
        }
    }
}
